; This utility prints out the full file name of all files in the current folder and
;   all sub folders. It does not change folders or use recursion.  This is a console application.
.nolist
include \masm32\include\masm32rt.inc
.listall
.data
fcount  dd 0	; count files
.data?
FileN db 260 dup (?) 	; the current full path
pFile dd ?				; where the zerobyte terminator for path is.
.code
inv equ invoke
Program:
	inv GetCurrentDirectory,260,addr FileN  ; or you could hardcode any starting point
	add eax,offset FileN	; location of zero byte terminator
	mov pFile,eax  
    call FindAllFiles  		; go doit
    inv dwtoa,fcount,addr FileN
    print addr FileN," files total",13,10    
    inv ExitProcess, 0

.data?  ; for FIndAllFiles
wfd WIN32_FIND_DATA <?>
SearchHandle dd ?
LastFilePtr  dd ?
Level        dd ?
.code
FindAllFiles proc  ; assumes FileN contains full path to folder wanted,
                   ;   pFile points to zero byte terminator
    mov	Level,1	   ; start at first level
ReStart:
	mov eax,pFile
	cmp byte ptr [eax-1],'\'	; add trailing slash if needed
	je 	HaveSlash
	mov word ptr [eax],005Ch	; backslash plus zero byte terminator
	inc eax
	inc pFile
HaveSlash:
	mov LastFilePtr,eax			; save pointer to end of string
	mov dword ptr [eax],002A2E2Ah	; set "*.*" search pattern, including zero byte terminator
    inv FindFirstFile,offset FileN,ADDR wfd
    mov SearchHandle,eax
    cmp eax,INVALID_HANDLE_VALUE  ; (-1)
    je	continue				; out of files, go move up or quit
	jmp @f						; already have one, skip over findnext

iloop:
	inv FindNextFile, SearchHandle,ADDR wfd
    or 	eax,eax
    jz 	CloseSearchHandle	; out of files in this folder
@@:
    mov edx,offset wfd.cFileName
    cmp byte ptr [edx],'.'	; discard current and parent directory
    je 	iloop
  	mov ecx,LastFilePtr		; still have address of wfd.cFileName in edx
@@:
	mov al,byte ptr [edx]	; tack new file or folder name onto current folder
	mov byte ptr [ecx],al
	inc edx
	inc ecx
	or 	al,al
	jnz	@b
    test wfd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY	; was it a new folder?
    jnz	DoNewFolder			; go do files in new folder
   	print addr FileN,13,10	; not a folder, print the file name
   	inc fcount
   	jmp iloop
DoNewFolder:
	dec ecx
  	mov pFile,ecx		; save new pointer
	push LastFilePtr	; save current position
	push SearchHandle	; save current search handle
	inc Level			; keep track of how deep we are into subfolders
	jmp ReStart			; pFile already set, go get all the files in this new folder
	
CloseSearchHandle:
	inv FindClose,SearchHandle	; done with this search handle, close it
continue:
	dec	Level	; are we done
	jnz	@f
	ret
@@:
	pop SearchHandle
	pop eax				; get current position within path string
	mov LastFilePtr,eax ; back to where we started
	mov pFile,eax
    jmp iloop

FindAllFiles endp

end Program





















